Index: branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90
===================================================================
--- branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 8215)
+++ branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 8568)
@@ -1403,9 +1358,9 @@
             END DO
          END DO
-
+         !
       ELSE
-           CALL ctl_stop( 'invalid polynomial type in cspline' )
-      ENDIF
-
+         CALL ctl_stop( 'invalid polynomial type in cspline' )
+      ENDIF
+      !
    END SUBROUTINE cspline
 
Index: branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynkeg.F90
===================================================================
--- branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynkeg.F90	(revision 8215)
+++ branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynkeg.F90	(revision 8568)
@@ -22,5 +22,4 @@
    USE lib_mpp         ! MPP library
    USE prtctl          ! Print control
-   USE wrk_nemo        ! Memory Allocation
    USE timing          ! Timing
    USE bdy_oce         ! ocean open boundary conditions
@@ -39,5 +38,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.6 , NEMO Consortium (2015)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2017)
    !! $Id$ 
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -75,16 +74,13 @@
       INTEGER, INTENT( in ) ::   kscheme   ! =0/1   type of KEG scheme 
       !
-      INTEGER  ::   ji, jj, jk   ! dummy loop indices
-      REAL(wp) ::   zu, zv       ! temporary scalars
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zhke
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: ztrdu, ztrdv 
-      INTEGER  ::   jb                 ! dummy loop indices
-      INTEGER  ::   ii, ij, igrd, ib_bdy   ! local integers
-      INTEGER  ::   fu, fv
+      INTEGER  ::   ji, jj, jk, jb    ! dummy loop indices
+      INTEGER  ::   ii, ifu, ib_bdy   ! local integers
+      INTEGER  ::   ij, ifv, igrd     !   -       -
+      REAL(wp) ::   zu, zv            ! local scalars
+      REAL(wp), DIMENSION(jpi,jpj,jpk)        ::   zhke
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   ztrdu, ztrdv 
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )   CALL timing_start('dyn_keg')
-      !
-      CALL wrk_alloc( jpi,jpj,jpk,   zhke )
+      IF( ln_timing )   CALL timing_start('dyn_keg')
       !
       IF( kt == nit000 ) THEN
@@ -94,6 +90,6 @@
       ENDIF
 
-      IF( l_trddyn ) THEN           ! Save ua and va trends
-         CALL wrk_alloc( jpi,jpj,jpk,   ztrdu, ztrdv )
+      IF( l_trddyn ) THEN           ! Save the input trends
+         ALLOCATE( ztrdu(jpi,jpj,jpk) , ztrdv(jpi,jpj,jpk) )
          ztrdu(:,:,:) = ua(:,:,:) 
          ztrdv(:,:,:) = va(:,:,:) 
@@ -112,6 +108,6 @@
                      ii   = idx_bdy(ib_bdy)%nbi(jb,igrd)
                      ij   = idx_bdy(ib_bdy)%nbj(jb,igrd)
-                     fu   = NINT( idx_bdy(ib_bdy)%flagu(jb,igrd) )
-                     un(ii-fu,ij,jk) = un(ii,ij,jk) * umask(ii,ij,jk)
+                     ifu   = NINT( idx_bdy(ib_bdy)%flagu(jb,igrd) )
+                     un(ii-ifu,ij,jk) = un(ii,ij,jk) * umask(ii,ij,jk)
                   END DO
                END DO
@@ -122,6 +118,6 @@
                      ii   = idx_bdy(ib_bdy)%nbi(jb,igrd)
                      ij   = idx_bdy(ib_bdy)%nbj(jb,igrd)
-                     fv   = NINT( idx_bdy(ib_bdy)%flagv(jb,igrd) )
-                     vn(ii,ij-fv,jk) = vn(ii,ij,jk) * vmask(ii,ij,jk)
+                     ifv   = NINT( idx_bdy(ib_bdy)%flagv(jb,igrd) )
+                     vn(ii,ij-ifv,jk) = vn(ii,ij,jk) * vmask(ii,ij,jk)
                   END DO
                END DO
@@ -172,5 +168,4 @@
       ENDIF      
 
-
       !
       DO jk = 1, jpkm1                    !==  grad( KE ) added to the general momentum trends  ==!
@@ -187,5 +182,5 @@
          ztrdv(:,:,:) = va(:,:,:) - ztrdv(:,:,:)
          CALL trd_dyn( ztrdu, ztrdv, jpdyn_keg, kt )
-         CALL wrk_dealloc( jpi,jpj,jpk,   ztrdu, ztrdv )
+         DEALLOCATE( ztrdu , ztrdv )
       ENDIF
       !
@@ -193,7 +188,5 @@
          &                       tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
       !
-      CALL wrk_dealloc( jpi,jpj,jpk,   zhke )
-      !
-      IF( nn_timing == 1 )   CALL timing_stop('dyn_keg')
+      IF( ln_timing )   CALL timing_stop('dyn_keg')
       !
    END SUBROUTINE dyn_keg
Index: branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90
===================================================================
--- branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90	(revision 8215)
+++ branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90	(revision 8568)
@@ -27,5 +27,4 @@
    USE lib_mpp        ! distribued memory computing library
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
-   USE wrk_nemo       ! Memory Allocation
    USE timing         ! Timing
 
@@ -48,5 +47,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.7 , NEMO Consortium (2015)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2017)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -62,11 +61,11 @@
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  ztrdu, ztrdv
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   ztrdu, ztrdv
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('dyn_ldf')
+      IF( ln_timing )   CALL timing_start('dyn_ldf')
       !
       IF( l_trddyn )   THEN                      ! temporary save of momentum trends
-         CALL wrk_alloc( jpi,jpj,jpk,   ztrdu, ztrdv )
+         ALLOCATE( ztrdu(jpi,jpj,jpk) , ztrdv(jpi,jpj,jpk) )
          ztrdu(:,:,:) = ua(:,:,:) 
          ztrdv(:,:,:) = va(:,:,:) 
@@ -85,5 +84,5 @@
          ztrdv(:,:,:) = va(:,:,:) - ztrdv(:,:,:)
          CALL trd_dyn( ztrdu, ztrdv, jpdyn_ldf, kt )
-         CALL wrk_dealloc( jpi,jpj,jpk,   ztrdu, ztrdv )
+         DEALLOCATE ( ztrdu , ztrdv )
       ENDIF
       !                                          ! print sum trends (used for debugging)
@@ -91,5 +90,5 @@
          &                       tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
       !
-      IF( nn_timing == 1 )  CALL timing_stop('dyn_ldf')
+      IF( ln_timing )   CALL timing_stop('dyn_ldf')
       !
    END SUBROUTINE dyn_ldf
@@ -102,50 +101,52 @@
       !! ** Purpose :   initializations of the horizontal ocean dynamics physics
       !!----------------------------------------------------------------------
-      INTEGER ::   ioptio, ierr         ! temporary integers 
+      INTEGER ::   ioptio, ierr   ! temporary integers 
       !!----------------------------------------------------------------------
       !
-      !                                   ! Namelist nam_dynldf: already read in ldfdyn module
+      !                                !==  Namelist nam_dynldf  ==!   already read in ldfdyn module
       !
-      IF(lwp) THEN                        ! Namelist print
+      IF(lwp) THEN                     !== Namelist print  ==!
          WRITE(numout,*)
          WRITE(numout,*) 'dyn_ldf_init : Choice of the lateral diffusive operator on dynamics'
          WRITE(numout,*) '~~~~~~~~~~~~'
          WRITE(numout,*) '   Namelist nam_dynldf : set lateral mixing parameters (type, direction, coefficients)'
-         WRITE(numout,*) '      laplacian operator          ln_dynldf_lap = ', ln_dynldf_lap
-         WRITE(numout,*) '      bilaplacian operator        ln_dynldf_blp = ', ln_dynldf_blp
-         WRITE(numout,*) '      iso-level                   ln_dynldf_lev = ', ln_dynldf_lev
-         WRITE(numout,*) '      horizontal (geopotential)   ln_dynldf_hor = ', ln_dynldf_hor
-         WRITE(numout,*) '      iso-neutral                 ln_dynldf_iso = ', ln_dynldf_iso
+         WRITE(numout,*) '      Type of operator'
+         WRITE(numout,*) '         no explicit diffusion       ln_dynldf_NONE = ', ln_dynldf_NONE
+         WRITE(numout,*) '         laplacian operator          ln_dynldf_lap  = ', ln_dynldf_lap
+         WRITE(numout,*) '         bilaplacian operator        ln_dynldf_blp  = ', ln_dynldf_blp
+         WRITE(numout,*) '      Direction of action'
+         WRITE(numout,*) '         iso-level                   ln_dynldf_lev  = ', ln_dynldf_lev
+         WRITE(numout,*) '         horizontal (geopotential)   ln_dynldf_hor  = ', ln_dynldf_hor
+         WRITE(numout,*) '         iso-neutral                 ln_dynldf_iso  = ', ln_dynldf_iso
       ENDIF
-      !                                   ! use of lateral operator or not
+      !                                !==  use of lateral operator or not  ==!
       nldf = np_ERROR
       ioptio = 0
-      IF( ln_dynldf_lap )   ioptio = ioptio + 1
-      IF( ln_dynldf_blp )   ioptio = ioptio + 1
-      IF( ioptio >  1   )   CALL ctl_stop( 'dyn_ldf_init: use ONE or NONE of the 2 lap/bilap operator type on momentum' )
-      IF( ioptio == 0   )   nldf = np_no_ldf     ! No lateral mixing operator
+      IF( ln_dynldf_NONE ) THEN   ;   nldf = np_no_ldf   ;   ioptio = ioptio + 1   ;   ENDIF
+      IF( ln_dynldf_lap  ) THEN   ;                          ioptio = ioptio + 1   ;   ENDIF
+      IF( ln_dynldf_blp  ) THEN   ;                          ioptio = ioptio + 1   ;   ENDIF
+      IF( ioptio /= 1    )   CALL ctl_stop( 'dyn_ldf_init: use ONE of the 3 operator options (NONE/lap/blp)' )
       !
-      IF( nldf /= np_no_ldf ) THEN        ! direction ==>> type of operator  
+      IF(.NOT.ln_dynldf_NONE ) THEN    !==  direction ==>> type of operator  ==!
          ioptio = 0
          IF( ln_dynldf_lev )   ioptio = ioptio + 1
          IF( ln_dynldf_hor )   ioptio = ioptio + 1
          IF( ln_dynldf_iso )   ioptio = ioptio + 1
-         IF( ioptio >  1   )   CALL ctl_stop( '          use only ONE direction (level/hor/iso)' )
-         IF( ioptio == 0   )   CALL ctl_stop( '          use at least ONE direction (level/hor/iso)' )
+         IF( ioptio /= 1   )   CALL ctl_stop( 'dyn_ldf_init: use ONE of the 3 direction options (level/hor/iso)' )
          !
-         !                                   ! Set nldf, the type of lateral diffusion, from ln_dynldf_... logicals
+         !                             ! Set nldf, the type of lateral diffusion, from ln_dynldf_... logicals
          ierr = 0
-         IF ( ln_dynldf_lap ) THEN      ! laplacian operator
-            IF ( ln_zco ) THEN                ! z-coordinate
+         IF( ln_dynldf_lap ) THEN         ! laplacian operator
+            IF( ln_zco ) THEN                ! z-coordinate
                IF ( ln_dynldf_lev )   nldf = np_lap     ! iso-level = horizontal (no rotation)
                IF ( ln_dynldf_hor )   nldf = np_lap     ! iso-level = horizontal (no rotation)
                IF ( ln_dynldf_iso )   nldf = np_lap_i   ! iso-neutral            (   rotation)
             ENDIF
-            IF ( ln_zps ) THEN             ! z-coordinate with partial step
+            IF( ln_zps ) THEN                ! z-coordinate with partial step
                IF ( ln_dynldf_lev )   nldf = np_lap     ! iso-level              (no rotation)
                IF ( ln_dynldf_hor )   nldf = np_lap     ! iso-level              (no rotation)
                IF ( ln_dynldf_iso )   nldf = np_lap_i   ! iso-neutral            (   rotation)
             ENDIF
-            IF ( ln_sco ) THEN             ! s-coordinate
+            IF( ln_sco ) THEN                ! s-coordinate
                IF ( ln_dynldf_lev )   nldf = np_lap     ! iso-level = horizontal (no rotation)
                IF ( ln_dynldf_hor )   nldf = np_lap_i   ! horizontal             (   rotation)
@@ -154,19 +155,19 @@
          ENDIF
          !
-         IF( ln_dynldf_blp ) THEN          ! bilaplacian operator
-            IF ( ln_zco ) THEN                ! z-coordinate
-               IF ( ln_dynldf_lev )   nldf = np_blp     ! iso-level = horizontal (no rotation)
-               IF ( ln_dynldf_hor )   nldf = np_blp     ! iso-level = horizontal (no rotation)
-               IF ( ln_dynldf_iso )   ierr = 2          ! iso-neutral            (   rotation)
+         IF( ln_dynldf_blp ) THEN         ! bilaplacian operator
+            IF( ln_zco ) THEN                ! z-coordinate
+               IF( ln_dynldf_lev )   nldf = np_blp     ! iso-level = horizontal (no rotation)
+               IF( ln_dynldf_hor )   nldf = np_blp     ! iso-level = horizontal (no rotation)
+               IF( ln_dynldf_iso )   ierr = 2          ! iso-neutral            (   rotation)
             ENDIF
-            IF ( ln_zps ) THEN             ! z-coordinate with partial step
-               IF ( ln_dynldf_lev )   nldf = np_blp     ! iso-level              (no rotation)
-               IF ( ln_dynldf_hor )   nldf = np_blp     ! iso-level              (no rotation)
-               IF ( ln_dynldf_iso )   ierr = 2          ! iso-neutral            (   rotation)
+            IF( ln_zps ) THEN                ! z-coordinate with partial step
+               IF( ln_dynldf_lev )   nldf = np_blp     ! iso-level              (no rotation)
+               IF( ln_dynldf_hor )   nldf = np_blp     ! iso-level              (no rotation)
+               IF( ln_dynldf_iso )   ierr = 2          ! iso-neutral            (   rotation)
             ENDIF
-            IF ( ln_sco ) THEN             ! s-coordinate
-               IF ( ln_dynldf_lev )   nldf = np_blp     ! iso-level              (no rotation)
-               IF ( ln_dynldf_hor )   ierr = 2          ! horizontal             (   rotation)
-               IF ( ln_dynldf_iso )   ierr = 2          ! iso-neutral            (   rotation)
+            IF( ln_sco ) THEN                ! s-coordinate
+               IF( ln_dynldf_lev )   nldf = np_blp     ! iso-level              (no rotation)
+               IF( ln_dynldf_hor )   ierr = 2          ! horizontal             (   rotation)
+               IF( ln_dynldf_iso )   ierr = 2          ! iso-neutral            (   rotation)
             ENDIF
          ENDIF
Index: branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_iso.F90
===================================================================
--- branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_iso.F90	(revision 8215)
+++ branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_iso.F90	(revision 8568)
@@ -28,5 +28,4 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE prtctl          ! Print control
-   USE wrk_nemo        ! Memory Allocation
    USE timing          ! Timing
 
@@ -45,5 +44,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2011)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2017)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -108,15 +107,12 @@
       !
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
-      REAL(wp) ::   zabe1, zabe2, zcof1, zcof2                       ! local scalars
-      REAL(wp) ::   zmskt, zmskf                                     !   -      -
-      REAL(wp) ::   zcoef0, zcoef3, zcoef4, zmkt, zmkf               !   -      -
-      REAL(wp) ::   zuav, zvav, zuwslpi, zuwslpj, zvwslpi, zvwslpj   !   -      -
-      !
-      REAL(wp), POINTER, DIMENSION(:,:) :: ziut, zjuf, zjvt, zivf, zdku, zdk1u, zdkv, zdk1v
+      REAL(wp) ::   zabe1, zmskt, zmkt, zuav, zuwslpi, zuwslpj   ! local scalars
+      REAL(wp) ::   zabe2, zmskf, zmkf, zvav, zvwslpi, zvwslpj   !   -      -
+      REAL(wp) ::   zcof0, zcof1, zcof2, zcof3, zcof4            !   -      -
+      REAL(wp), DIMENSION(jpi,jpj) ::   ziut, zivf, zdku, zdk1u  ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj) ::   zjuf, zjvt, zdkv, zdk1v  !  -      -
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('dyn_ldf_iso')
-      !
-      CALL wrk_alloc( jpi, jpj, ziut, zjuf, zjvt, zivf, zdku, zdk1u, zdkv, zdk1v ) 
+      IF( ln_timing )   CALL timing_start('dyn_ldf_iso')
       !
       IF( kt == nit000 ) THEN
@@ -343,23 +339,23 @@
          DO jk = 2, jpkm1
             DO ji = 2, jpim1
-               zcoef0= 0.5 * rn_aht_0 * umask(ji,jj,jk)
+               zcof0 = 0.5_wp * rn_aht_0 * umask(ji,jj,jk)
                !
-               zuwslpi = zcoef0 * ( wslpi(ji+1,jj,jk) + wslpi(ji,jj,jk) )
-               zuwslpj = zcoef0 * ( wslpj(ji+1,jj,jk) + wslpj(ji,jj,jk) )
+               zuwslpi = zcof0 * ( wslpi(ji+1,jj,jk) + wslpi(ji,jj,jk) )
+               zuwslpj = zcof0 * ( wslpj(ji+1,jj,jk) + wslpj(ji,jj,jk) )
                !
-               zmkt = 1./MAX(  tmask(ji,jj,jk-1)+tmask(ji+1,jj,jk-1)   &
-                             + tmask(ji,jj,jk  )+tmask(ji+1,jj,jk  ), 1. )
-               zmkf = 1./MAX(  fmask(ji,jj-1,jk-1) + fmask(ji,jj,jk-1)   &
-                             + fmask(ji,jj-1,jk  ) + fmask(ji,jj,jk  ), 1. )
-
-               zcoef3 = - e2u(ji,jj) * zmkt * zuwslpi
-               zcoef4 = - e1u(ji,jj) * zmkf * zuwslpj
+               zmkt = 1./MAX(  tmask(ji,jj,jk-1)+tmask(ji+1,jj,jk-1)      &
+                             + tmask(ji,jj,jk  )+tmask(ji+1,jj,jk  ) , 1. )
+               zmkf = 1./MAX(  fmask(ji,jj-1,jk-1) + fmask(ji,jj,jk-1)      &
+                             + fmask(ji,jj-1,jk  ) + fmask(ji,jj,jk  ) , 1. )
+
+               zcof3 = - e2u(ji,jj) * zmkt * zuwslpi
+               zcof4 = - e1u(ji,jj) * zmkf * zuwslpj
                ! vertical flux on u field
-               zfuw(ji,jk) = zcoef3 * ( zdiu (ji,jk-1) + zdiu (ji+1,jk-1)     &
-                                       +zdiu (ji,jk  ) + zdiu (ji+1,jk  ) )   &
-                           + zcoef4 * ( zdj1u(ji,jk-1) + zdju (ji  ,jk-1)     &
-                                       +zdj1u(ji,jk  ) + zdju (ji  ,jk  ) )
+               zfuw(ji,jk) = zcof3 * (  zdiu (ji,jk-1) + zdiu (ji+1,jk-1)      &
+                  &                   + zdiu (ji,jk  ) + zdiu (ji+1,jk  )  )   &
+                  &        + zcof4 * (  zdj1u(ji,jk-1) + zdju (ji  ,jk-1)      &
+                  &                   + zdj1u(ji,jk  ) + zdju (ji  ,jk  )  )
                ! vertical mixing coefficient (akzu)
-               ! Note: zcoef0 include rn_aht_0, so divided by rn_aht_0 to obtain slp^2 * rn_aht_0
+               ! Note: zcof0 include rn_aht_0, so divided by rn_aht_0 to obtain slp^2 * rn_aht_0
                akzu(ji,jj,jk) = ( zuwslpi * zuwslpi + zuwslpj * zuwslpj ) / rn_aht_0
             END DO
@@ -369,23 +365,23 @@
          DO jk = 2, jpkm1
             DO ji = 2, jpim1
-               zcoef0 = 0.5 * rn_aht_0 * vmask(ji,jj,jk)
-
-               zvwslpi = zcoef0 * ( wslpi(ji,jj+1,jk) + wslpi(ji,jj,jk) )
-               zvwslpj = zcoef0 * ( wslpj(ji,jj+1,jk) + wslpj(ji,jj,jk) )
-
-               zmkf = 1./MAX(  fmask(ji-1,jj,jk-1)+fmask(ji,jj,jk-1)   &
-                             + fmask(ji-1,jj,jk  )+fmask(ji,jj,jk  ), 1. )
-               zmkt = 1./MAX(  tmask(ji,jj,jk-1)+tmask(ji,jj+1,jk-1)   &
-                             + tmask(ji,jj,jk  )+tmask(ji,jj+1,jk  ), 1. )
-
-               zcoef3 = - e2v(ji,jj) * zmkf * zvwslpi
-               zcoef4 = - e1v(ji,jj) * zmkt * zvwslpj
+               zcof0 = 0.5_wp * rn_aht_0 * vmask(ji,jj,jk)
+               !
+               zvwslpi = zcof0 * ( wslpi(ji,jj+1,jk) + wslpi(ji,jj,jk) )
+               zvwslpj = zcof0 * ( wslpj(ji,jj+1,jk) + wslpj(ji,jj,jk) )
+               !
+               zmkf = 1./MAX(  fmask(ji-1,jj,jk-1)+fmask(ji,jj,jk-1)      &
+                  &          + fmask(ji-1,jj,jk  )+fmask(ji,jj,jk  ) , 1. )
+               zmkt = 1./MAX(  tmask(ji,jj,jk-1)+tmask(ji,jj+1,jk-1)      &
+                  &          + tmask(ji,jj,jk  )+tmask(ji,jj+1,jk  ) , 1. )
+
+               zcof3 = - e2v(ji,jj) * zmkf * zvwslpi
+               zcof4 = - e1v(ji,jj) * zmkt * zvwslpj
                ! vertical flux on v field
-               zfvw(ji,jk) = zcoef3 * ( zdiv (ji,jk-1) + zdiv (ji-1,jk-1)     &
-                  &                    +zdiv (ji,jk  ) + zdiv (ji-1,jk  ) )   &
-                  &        + zcoef4 * ( zdjv (ji,jk-1) + zdj1v(ji  ,jk-1)     &
-                  &                    +zdjv (ji,jk  ) + zdj1v(ji  ,jk  ) )
+               zfvw(ji,jk) = zcof3 * (  zdiv (ji,jk-1) + zdiv (ji-1,jk-1)      &
+                  &                   + zdiv (ji,jk  ) + zdiv (ji-1,jk  )  )   &
+                  &        + zcof4 * (  zdjv (ji,jk-1) + zdj1v(ji  ,jk-1)      &
+                  &                   + zdjv (ji,jk  ) + zdj1v(ji  ,jk  )  )
                ! vertical mixing coefficient (akzv)
-               ! Note: zcoef0 include rn_aht_0, so divided by rn_aht_0 to obtain slp^2 * rn_aht_0
+               ! Note: zcof0 include rn_aht_0, so divided by rn_aht_0 to obtain slp^2 * rn_aht_0
                akzv(ji,jj,jk) = ( zvwslpi * zvwslpi + zvwslpj * zvwslpj ) / rn_aht_0
             END DO
@@ -404,7 +400,6 @@
       END DO                                           !   End of slab
       !                                                ! ===============
-      CALL wrk_dealloc( jpi, jpj, ziut, zjuf, zjvt, zivf, zdku, zdk1u, zdkv, zdk1v ) 
       !
-      IF( nn_timing == 1 )  CALL timing_stop('dyn_ldf_iso')
+      IF( ln_timing )   CALL timing_stop('dyn_ldf_iso')
       !
    END SUBROUTINE dyn_ldf_iso
Index: branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_lap_blp.F90
===================================================================
--- branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_lap_blp.F90	(revision 8215)
+++ branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_lap_blp.F90	(revision 8568)
@@ -19,5 +19,4 @@
    USE in_out_manager ! I/O manager
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
-   USE wrk_nemo       ! Memory Allocation
    USE timing         ! Timing
 
@@ -31,5 +30,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.7 , NEMO Consortium (2014)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2017)
    !! $Id$ 
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -57,5 +56,5 @@
       REAL(wp) ::   zsign        ! local scalars
       REAL(wp) ::   zua, zva     ! local scalars
-      REAL(wp), POINTER, DIMENSION(:,:) ::  zcur, zdiv
+      REAL(wp), DIMENSION(jpi,jpj) ::   zcur, zdiv
       !!----------------------------------------------------------------------
       !
@@ -66,7 +65,5 @@
       ENDIF
       !
-      IF( nn_timing == 1 )   CALL timing_start('dyn_ldf_lap')
-      !
-      CALL wrk_alloc( jpi, jpj, zcur, zdiv ) 
+      IF( ln_timing )   CALL timing_start('dyn_ldf_lap')
       !
       IF( kpass == 1 ) THEN   ;   zsign =  1._wp      ! bilaplacian operator require a minus sign
@@ -107,7 +104,6 @@
       END DO                                           !   End of slab
       !                                                ! ===============
-      CALL wrk_dealloc( jpi, jpj, zcur, zdiv ) 
       !
-      IF( nn_timing == 1 )  CALL timing_stop('dyn_ldf_lap')
+      IF( ln_timing )   CALL timing_stop('dyn_ldf_lap')
       !
    END SUBROUTINE dyn_ldf_lap
@@ -131,10 +127,8 @@
       REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pua, pva   ! momentum trend
       !
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zulap, zvlap   ! laplacian at u- and v-point
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zulap, zvlap   ! laplacian at u- and v-point
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('dyn_ldf_blp')
-      !
-      CALL wrk_alloc( jpi, jpj, jpk, zulap, zvlap ) 
+      IF( ln_timing )   CALL timing_start('dyn_ldf_blp')
       !
       IF( kt == nit000 )  THEN
@@ -154,7 +148,5 @@
       CALL dyn_ldf_lap( kt, zulap, zvlap, pua, pva, 2 )   ! rotated laplacian applied to zlap (output in pta)
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, zulap, zvlap ) 
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('dyn_ldf_blp')
+      IF( ln_timing )   CALL timing_stop('dyn_ldf_blp')
       !
    END SUBROUTINE dyn_ldf_blp
Index: branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90
===================================================================
--- branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 8215)
+++ branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 8568)
@@ -44,5 +44,4 @@
    USE lbclnk         ! lateral boundary condition (or mpp link)
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! Memory Allocation
    USE prtctl         ! Print control
    USE timing         ! Timing
@@ -57,5 +56,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2017)
    !! $Id$ 
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -97,12 +96,11 @@
       REAL(wp) ::   zue3a, zue3n, zue3b, zuf, zcoef    ! local scalars
       REAL(wp) ::   zve3a, zve3n, zve3b, zvf, z1_2dt   !   -      -
-      REAL(wp), POINTER, DIMENSION(:,:)   ::  zue, zve
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  ze3u_f, ze3v_f, zua, zva 
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::   zue, zve
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   ze3u_f, ze3v_f, zua, zva 
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )   CALL timing_start('dyn_nxt')
-      !
-      IF( ln_dynspg_ts       )   CALL wrk_alloc( jpi,jpj,       zue, zve)
-      IF( l_trddyn           )   CALL wrk_alloc( jpi,jpj,jpk,   zua, zva)
+      IF( ln_timing    )   CALL timing_start('dyn_nxt')
+      IF( ln_dynspg_ts )   ALLOCATE( zue(jpi,jpj)     , zve(jpi,jpj)     )
+      IF( l_trddyn     )   ALLOCATE( zua(jpi,jpj,jpk) , zva(jpi,jpj,jpk) )
       !
       IF( kt == nit000 ) THEN
@@ -253,5 +251,5 @@
             ELSE                          ! Asselin filter applied on thickness weighted velocity
                !
-               CALL wrk_alloc( jpi,jpj,jpk,   ze3u_f, ze3v_f )
+               ALLOCATE( ze3u_f(jpi,jpj,jpk) , ze3v_f(jpi,jpj,jpk) )
                ! Before filtered scale factor at (u/v)-points stored in ze3u_f, ze3v_f
                CALL dom_vvl_interpol( e3t_b(:,:,:), ze3u_f, 'U' )
@@ -280,5 +278,5 @@
                e3v_b(:,:,1:jpkm1) = ze3v_f(:,:,1:jpkm1)
                !
-               CALL wrk_dealloc( jpi,jpj,jpk,   ze3u_f, ze3v_f )
+               DEALLOCATE( ze3u_f , ze3v_f )
             ENDIF
             !
@@ -346,8 +344,7 @@
          &                       tab3d_2=vn, clinfo2=' Vn: '       , mask2=vmask )
       ! 
-      IF( ln_dynspg_ts )   CALL wrk_dealloc( jpi,jpj,       zue, zve )
-      IF( l_trddyn     )   CALL wrk_dealloc( jpi,jpj,jpk,   zua, zva )
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('dyn_nxt')
+      IF( ln_dynspg_ts )   DEALLOCATE( zue, zve )
+      IF( l_trddyn     )   DEALLOCATE( zua, zva )
+      IF( ln_timing    )   CALL timing_stop('dyn_nxt')
       !
    END SUBROUTINE dyn_nxt
Index: branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90
===================================================================
--- branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90	(revision 8215)
+++ branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90	(revision 8568)
@@ -28,5 +28,4 @@
    USE in_out_manager ! I/O manager
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! Memory Allocation
    USE timing         ! Timing
 
@@ -47,5 +46,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LODYC-IPSL  (2009)
+   !! NEMO/OPA 4.0 , LODYC-IPSL  (2017)
    !! $Id$ 
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -71,16 +70,16 @@
       !!             period is used to prevent the divergence of odd and even time step.
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in   ) ::   kt       ! ocean time-step index
-      !
-      INTEGER  ::   ji, jj, jk                             ! dummy loop indices
-      REAL(wp) ::   z2dt, zg_2, zintp, zgrau0r             ! temporary scalar
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  ztrdu, ztrdv
-      REAL(wp), POINTER, DIMENSION(:,:)   ::  zpice
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('dyn_spg')
+      INTEGER, INTENT(in   ) ::   kt   ! ocean time-step index
+      !
+      INTEGER  ::   ji, jj, jk                   ! dummy loop indices
+      REAL(wp) ::   z2dt, zg_2, zintp, zgrau0r   ! local scalars
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::   zpice
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   ztrdu, ztrdv
+      !!----------------------------------------------------------------------
+      !
+      IF( ln_timing )   CALL timing_start('dyn_spg')
       !
       IF( l_trddyn )   THEN                      ! temporary save of ta and sa trends
-         CALL wrk_alloc( jpi,jpj,jpk,   ztrdu, ztrdv ) 
+         ALLOCATE( ztrdu(jpi,jpj,jpk) , ztrdv(jpi,jpj,jpk) ) 
          ztrdu(:,:,:) = ua(:,:,:)
          ztrdv(:,:,:) = va(:,:,:)
@@ -124,6 +123,5 @@
          !
          IF( nn_ice_embd == 2 ) THEN          !== embedded sea ice: Pressure gradient due to snow-ice mass ==!
-            CALL wrk_alloc( jpi,jpj,   zpice )
-            !                                            
+            ALLOCATE( zpice(jpi,jpj) )
             zintp = REAL( MOD( kt-1, nn_fsbc ) ) / REAL( nn_fsbc )
             zgrau0r     = - grav * r1_rau0
@@ -135,6 +133,5 @@
                END DO
             END DO
-            !
-            CALL wrk_dealloc( jpi,jpj,   zpice )         
+            DEALLOCATE( zpice )         
          ENDIF
          !
@@ -161,5 +158,5 @@
          ztrdv(:,:,:) = va(:,:,:) - ztrdv(:,:,:)
          CALL trd_dyn( ztrdu, ztrdv, jpdyn_spg, kt )
-         CALL wrk_dealloc( jpi,jpj,jpk,   ztrdu, ztrdv ) 
+         DEALLOCATE( ztrdu , ztrdv ) 
       ENDIF
       !                                      ! print mean trends (used for debugging)
@@ -167,5 +164,5 @@
          &                       tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
       !
-      IF( nn_timing == 1 )  CALL timing_stop('dyn_spg')
+      IF( ln_timing )   CALL timing_stop('dyn_spg')
       !
    END SUBROUTINE dyn_spg
@@ -186,5 +183,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('dyn_spg_init')
+      IF( ln_timing )   CALL timing_start('dyn_spg_init')
       !
       REWIND( numnam_ref )              ! Namelist namdyn_spg in reference namelist : Free surface
@@ -227,5 +224,5 @@
       ENDIF
       !
-      IF( nn_timing == 1 )  CALL timing_stop('dyn_spg_init')
+      IF( ln_timing )   CALL timing_stop('dyn_spg_init')
       !
    END SUBROUTINE dyn_spg_init
